<template>
  <lightning-card  variant="Narrow"  title={accountName} icon-name="standard:account">
  </lightning-card>

  <br/>
    <template if:true={ramCase}>
      <div class="c-container">
        <div class="slds-m-top_medium slds-m-bottom_x-large">
          <h2 class="slds-text-heading_medium slds-m-bottom_medium">{ramCase.Subject}</h2>  
          <h3>{ramCase.LocationNumber__r.Physical_Address_1__c}</h3>
          <h3>
            <lightning-formatted-address
              street={ramCase.LocationNumber__r.Physical_Address_2__c}
              city={ramCase.LocationNumber__r.City__c}
              province={ramCase.LocationNumber__r.Province__c}
              postal-code={ramCase.Postal_Code__c}   ></lightning-formatted-address>
          </h3>
        </div>    
      </div>

      <lightning-progress-indicator current-step={currentStep} type="path" variant="base">
        <lightning-progress-step label={assignedLbl} value="s0" ></lightning-progress-step>
        <lightning-progress-step label={inProgressLbl} value="s1" ></lightning-progress-step>
        <lightning-progress-step label={pendingPartsLbl} value="s2" ></lightning-progress-step>
        <lightning-progress-step label={pendingApprovalLbl} value="s3" ></lightning-progress-step>
        <lightning-progress-step label={closedLbl} value="s4" ></lightning-progress-step>
        <lightning-progress-step label={completedLbl} value="s5" ></lightning-progress-step>
        <lightning-progress-step label={vendorCompletedLbl} value="s6" ></lightning-progress-step>
      </lightning-progress-indicator>      

      <br/>
      <lightning-button-group>
        <lightning-button label={inProgressLbl} disabled={inProgressDisabled} onclick={startWork} icon-name="utility:graph" variant="brand" class="slds-m-right_x-medium"></lightning-button>
        <lightning-button label={pendingPartsLbl}  disabled={pendingPartsDisabled} onclick={pendingParts} icon-name="utility:anchor" variant="brand" class="slds-m-left_x-small"></lightning-button>
        <lightning-button label={pendingApprovalLbl} disabled={pendingApprovalDisabled} onclick={pendingApproval} icon-name="utility:frozen" variant="brand" class="slds-m-left_x-small"></lightning-button>
        <lightning-button label={closedLbl} disabled={closedDisabled} onclick={workCompleted} icon-name="utility:like" variant="destructive" class="slds-m-left_x-small"></lightning-button>
        <lightning-button label={vendorCompletedLbl} disabled={vendorCompletedDisabled} onclick={vendorCompleted} icon-name="utility:success" variant="destructive" class="slds-m-left_x-small"></lightning-button>
      </lightning-button-group>

      <br/>
      <lightning-record-view-form 
                record-id={ramCase.Id}
                object-api-name="Case" >

        <lightning-messages></lightning-messages>
        
        <lightning-card variant="Narrow"  title="Ticket Information" icon-name="standard:insights">
          <lightning-layout-item size="12">
            <lightning-layout vertical-align="stretch" multiple-rows="true" class="x-large">           
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location #</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.LocationNumber__r.Name}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Ticket Number (R&M)</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Ticket_Number_R_M__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Name</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.LocationNumber__r.LocationName__c}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Status</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Status}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Summary</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Subject}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Status</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Vendor_Status__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>   
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Description</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Description}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Priority</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Priority}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item> 
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Type</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Equipment_Type__c}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Class</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Equipment_Class__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>                
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Tag</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.EquipmentTag__c}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Equipment Name</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.EquipmentName__r.Name}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item> 
            </lightning-layout>
          </lightning-layout-item> 
        </lightning-card>

        <br/>
        <lightning-card variant="Narrow"  title="Site/Location Details" icon-name="standard:instore_locations">
          <lightning-layout-item size="12">
            <lightning-layout vertical-align="stretch" multiple-rows="true" class="x-large">
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Name</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Vendor_Name_VA__c}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Retailer</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Retailer__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>                        
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Vendor Email</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                    <lightning-formatted-email value={ramCase.VendorEmail__c}></lightning-formatted-email>
                  </lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">District Manager</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.District_Manager__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item>                 
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Phone</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                    <lightning-formatted-phone value={ramCase.LocationNumber__r.Phone__c} ></lightning-formatted-phone>
                  </lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Type</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Location_Type__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item> 
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Maintenance Tech User</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Maintenance_Tech_User__r.Name}</lightning-layout-item>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Location Classification</lightning-layout-item>
                  <lightning-layout-item size="4" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">{ramCase.Location_Classification__c}</lightning-layout-item>                    
                </lightning-layout>
              </lightning-layout-item> 
              <lightning-layout-item size="12">
                <lightning-layout>
                  <lightning-layout-item size="2" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">Physical Address</lightning-layout-item>
                  <lightning-layout-item size="10" flexibility="auto" padding="around-small" class="custom-box" style="text-align: left;">
                    <lightning-formatted-address
                        street={ramCase.LocationNumber__r.Physical_Address_2__c}
                        city={ramCase.LocationNumber__r.City__c}
                        province={ramCase.LocationNumber__r.Province__c}
                        postal-code={ramCase.Postal_Code__c}   ></lightning-formatted-address>
                  </lightning-layout-item>
                </lightning-layout>
              </lightning-layout-item>     
            </lightning-layout>
          </lightning-layout-item>         
        </lightning-card>

        <br/>
        <lightning-card variant="Narrow"  title="Technician Assignment" icon-name="standard:task">
          <lightning-button label="Show Activities" onclick={openLocationMarkerModal} slot="actions"></lightning-button>
          <lightning-button label="Show Comments" onclick={openActivityCommentsModal} slot="actions"></lightning-button>
          <lightning-datatable data={assignedTechnicians}
                                columns={columns}
                                key-field="id"
                                show-row-number-column
                                onrowaction={handleRowAction}
                                hide-checkbox-column="true"></lightning-datatable>          
        </lightning-card>

        <br/>
        <lightning-card variant="Narrow"  title="Upload Files"  icon-name="action:upload">
          <lightning-file-upload
                  label="Attach File(s)"
                  name="fileUploader"
                  accept={acceptedFormats}
                  record-id={_recordId}
                  onuploadfinished={handleUploadFinished}
                  multiple></lightning-file-upload>
        </lightning-card>    
        <lightning-datatable data={availableFiles}
                          columns={fileColumns}
                          key-field="id"
                          show-row-number-column
                          hide-checkbox-column="true"></lightning-datatable>                
      </lightning-record-view-form>
    </template>


    <!--Confirmation modal to set the primary technician-->
    <template if:true={showPrimaryAssignmentModal}>
      <section role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal-medium">

        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closePrimaryAssignmentModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">Set Primary Technician</h2>
          </header>

          <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">
            Confirm {selectedRow.technicianName} as primary technician ?
          </div>
          <footer class="slds-modal__footer">
            <lightning-button label="Cancel" variant="neutral" onclick={closePrimaryAssignmentModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
            <lightning-button label={confirmButtonLabel} disabled={isUpdateDisabled} variant="brand" onclick={handlePrimaryAssignment}></lightning-button>
          </footer>            
        </div>
      </section>
      <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

    <!--Confirmation modal to remove the assignment-->
    <template if:true={showRemoveAssignmentModal}>
      <section role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal-medium">

        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeRemoveAssignmentModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 class="slds-text-heading_medium slds-hyphenate">Remove Assignment</h2>
          </header>

          <div class="slds-modal__content slds-p-around_medium" >
            Remove assignment for {selectedRow.technicianName} ?
          </div>
          <footer class="slds-modal__footer">
            <lightning-button label="Cancel" variant="neutral" onclick={closeRemoveAssignmentModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
            <lightning-button label={confirmButtonLabel} disabled={isUpdateDisabled} variant="brand" onclick={removeAssignment}></lightning-button>
          </footer>            
        </div>
      </section>
      <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

    <!--Reassign modal-->
    <template if:true={showReassignModal}>
      <section role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal-medium">

        <div class="slds-modal__container">
          <header class="slds-modal__header">
            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeReassignModal}>
              <lightning-icon icon-name="utility:close" size="medium">
              </lightning-icon>
              <span class="slds-assistive-text">Close</span>
            </button>
            <h2 class="slds-text-heading_medium slds-hyphenate">Reassign Technician</h2>
          </header>

          <div class="slds-modal__content slds-p-around_medium" >
            Select a technician to assign
            <lightning-radio-group name = "assignRadioButtons" 
                                  label="Select a technician to assign"
                                  options={availabelTechnicians}
                                  value={newlyAssignedTechnician}
                                  onchange={handleAssignmentSelection}
                                  required
                                  type="radio"></lightning-radio-group>            
          </div>
          <footer class="slds-modal__footer">
            <lightning-button label="Cancel" variant="neutral" onclick={closeReassignModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
            <lightning-button label={confirmButtonLabel} disabled={isUpdateDisabled} variant="brand" onclick={handleReassignment}></lightning-button>
          </footer>  
        </div>
      </section>
      <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

  <!--Status update comments modal-->
  <template if:true={showCommentsModal}>
    <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
  
      <div class="slds-modal__container">
        <header class="slds-modal__header">
          <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeCommentsModal}>
            <lightning-icon icon-name="utility:close" size="medium">
            </lightning-icon>
            <span class="slds-assistive-text">Close</span>
          </button>
          <h2 class="slds-text-heading_medium slds-hyphenate">Add Comments</h2>
        </header> 
        
        <div class="slds-modal__content slds-p-around_medium">
          <lightning-textarea
              name="comments"
              value={comments}
              label="Comments"
              onchange={handleCommentsChange}
              placeholder="Type your comments here">
          </lightning-textarea>
          <footer>
            <lightning-button label="Cancel" variant="neutral" onclick={closeCommentsModal}></lightning-button>&nbsp;&nbsp;&nbsp;&nbsp;
            <lightning-button label={commentsModalLbl} disabled={isCommentsModalLblDisabled} onclick={submitComments} variant="brand" type="submit"></lightning-button>
          </footer>           
        </div>
      </div>
    </section>
    <div class="slds-backdrop slds-backdrop_open"></div>
  </template>


  <!--Display Map markers in Google map-->
  <template if:true={showLocationMarkerModal}>
    <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
  
      <div class="slds-modal__container">
        <header class="slds-modal__header">
          <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeLocationMarkerModal}>
            <lightning-icon icon-name="utility:close" size="medium">
            </lightning-icon>
            <span class="slds-assistive-text">Close</span>
          </button>
          <h2 class="slds-text-heading_medium slds-hyphenate">Technician Activities</h2>
        </header> 
        
        <div class="slds-modal__content slds-p-around_medium">
          <lightning-map
              map-markers={mapMarkers}
              ></lightning-map>
          <footer>
            <lightning-button label="Cancel" variant="neutral" onclick={closeLocationMarkerModal}></lightning-button>
          </footer>           
        </div>
      </div>
    </section>
    <div class="slds-backdrop slds-backdrop_open"></div>
  </template>  

  <!--Show Activity Comments modal-->
  <template if:true={showActivityCommentsModal}>
    <section role="dialog"
              tabindex="-1"
              aria-labelledby="modal-heading-01"
              aria-modal="true"
              aria-describedby="modal-content-id-1"
              class="slds-modal slds-fade-in-open slds-modal-medium">
    
    <div class="slds-modal__container">
      <header class="slds-modal__header">
        <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeActivityCommentsModal}>
          <lightning-icon icon-name="utility:close" size="medium">
          </lightning-icon>
          <span class="slds-assistive-text">Close</span>
        </button>
        <h2 class="slds-text-heading_medium slds-hyphenate">Technician Comments</h2>
      </header> 
      <div class="slds-modal__content slds-p-around_medium">
        <lightning-datatable data={availableComments}
                            columns={commentsColumns}
                            key-field="id"
                            show-row-number-column
                            hide-checkbox-column="true"></lightning-datatable>            
      </div>
    </div>
    </section>
    <div class="slds-backdrop slds-backdrop_open"></div>
  </template>
  



</template>